## ros-kinetic-spinnaker-camera-driver 0.1.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)

set_directory_properties(PROPERTIES COMPILE_OPTIONS "-std=c++11;-Wall;-Wextra")


project(spinnaker_camera_driver)

find_package(catkin REQUIRED COMPONENTS
  camera_info_manager diagnostic_updater dynamic_reconfigure
  image_exposure_msgs image_transport nodelet roscpp sensor_msgs
  wfov_camera_msgs
)

find_package(OpenCV REQUIRED)

generate_dynamic_reconfigure_options(
  cfg/Spinnaker.cfg
)

catkin_package(CATKIN_DEPENDS
  image_exposure_msgs nodelet roscpp sensor_msgs wfov_camera_msgs
  DEPENDS OpenCV
)


# If Spinnacker is already present, use the found version. If not, download it.
# We can't resolve this dependency using the usual rosdep means because
# the Point Grey EULA prohibits redistributing the headers or the packages which
# contains them. We work around this by downloading the archive directly from
# their website during this step in the build process.
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")
find_package(Spinnaker QUIET)
if(NOT Spinnaker_FOUND)
  message(STATUS "libSpinnaker not found in system library path")
  include(cmake/DownloadSpinnaker.cmake)
  download_spinnaker(Spinnaker_LIBRARIES Spinnaker_INCLUDE_DIRS)
endif()

message(STATUS "libSpinnaker library: ${Spinnaker_LIBRARIES}")
message(STATUS "libSpinnaker include: ${Spinnaker_INCLUDE_DIRS}")


include_directories(SYSTEM
                    ${Spinnaker_INCLUDE_DIRS}
                    ${catkin_INCLUDE_DIRS}
                    ${OpenCV_INCLUDE_DIRS})
include_directories(include)

add_library(SpinnakerCameraLib src/SpinnakerCamera.cpp)

# Include the Spinnaker Libs
target_link_libraries(SpinnakerCameraLib
                      Camera
                      ${Spinnaker_LIBRARIES}
                      ${catkin_LIBRARIES}
                      ${OpenCV_LIBRARIES})


# Test Executable for Spinnaker
add_executable(spinnaker_test_node
              src/spinnaker_test_node.cpp
)

target_link_libraries(spinnaker_test_node
  SpinnakerCameraLib
  ${catkin_LIBRARIES}
)


add_dependencies(SpinnakerCameraLib ${PROJECT_NAME}_gencfg)


add_library(Camera src/camera.cpp)
target_link_libraries(Camera ${catkin_LIBRARIES})
add_dependencies(Camera ${PROJECT_NAME}_gencfg)

add_library(Cm3 src/cm3.cpp)
target_link_libraries(Cm3 Camera ${catkin_LIBRARIES})
add_dependencies(Cm3 ${PROJECT_NAME}_gencfg)

add_library(Diagnostics src/diagnostics.cpp)
target_link_libraries(Diagnostics Camera SpinnakerCameraLib ${catkin_LIBRARIES})
add_dependencies(Diagnostics ${PROJECT_NAME}_gencfg)

add_library(SpinnakerCameraNodelet src/nodelet.cpp)
target_link_libraries(SpinnakerCameraNodelet Diagnostics SpinnakerCameraLib Camera Cm3 ${catkin_LIBRARIES})

add_executable(spinnaker_camera_node src/node.cpp)
target_link_libraries(spinnaker_camera_node SpinnakerCameraLib ${catkin_LIBRARIES})
set_target_properties(spinnaker_camera_node PROPERTIES OUTPUT_NAME camera_node PREFIX "")

install(TARGETS
  SpinnakerCameraLib
  SpinnakerCameraNodelet
  Camera
  Cm3
  Diagnostics
  spinnaker_camera_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# Redistributing the flycapture .so file is permitted by the SDK EULA:
# http://www.ptgrey.com/support/kb/data/PGR-FlyCap-SDK-LA.pdf
if(EXISTS ${CMAKE_CURRENT_BINARY_DIR}/usr/lib)
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/usr/lib/ DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
           PATTERN libQt* EXCLUDE)
else()
  get_filename_component(Spinnaker_LIB_DIR ${Spinnaker_LIBRARIES} DIRECTORY)
  file(READ ${PROJECT_SOURCE_DIR}/cmake/install_files filenames)
  foreach(filename ${filenames})
    install(FILES ${Spinnaker_LIB_DIR}/${filename} DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})
  endforeach()
endif()

install(FILES nodelet_plugins.xml DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION} )

install(DIRECTORY launch DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

if (CATKIN_ENABLE_TESTING)
  find_package(roslaunch REQUIRED)
  roslaunch_add_file_check(launch/camera.launch)

  find_package(roslint REQUIRED)
  set(ROSLINT_CPP_OPTS "--filter=-build/c++11")
  roslint_cpp()
  roslint_add_test()
endif()

=== debian/changelog ===
ros-kinetic-spinnaker-camera-driver (0.1.3-0xenial) xenial; urgency=high

  * Fix install targets when Spinnaker is installed locally. Tabs in FindSpinnaker.
  * Add missing target (Cm3) and switch to find_package script. (#11 <https://github.com/ros-drivers/flir_camera_driver/issues/11>)
    * Add missing target (Cm3) and switch to find_package script.
    * Clean up message.
  * Adding support of feeding some camera diagnostics to the diagnostic a… (#4 <https://github.com/ros-drivers/flir_camera_driver/issues/4>)
    * Adding support of feeding some camera diagnostics to the diagnostic aggregator
    * Creating a seperate diagnostics launch example
  * Fix null conversion and unsigned comparison Warnings.
  * Contributors: Helen Oleynikova, Michael Hosmar, mlowe-ascent

 -- Mike Hosmar <mhosmar@clearpathrobotics.com>  Tue, 25 Sep 2018 04:00:00 -0000

ros-kinetic-spinnaker-camera-driver (0.1.2-0xenial) xenial; urgency=high

  * Add ARM Build Support (#3 <https://github.com/ros-drivers/flir_camera_driver/issues/3>)
    * Added ARM Build Support.
  * Contributors: Michael Hosmar

 -- Mike Hosmar <mhosmar@clearpathrobotics.com>  Fri, 27 Jul 2018 04:00:00 -0000

ros-kinetic-spinnaker-camera-driver (0.1.1-0xenial) xenial; urgency=high

  * Add opencv3 as build dependency.
  * Contributors: Michael Hosmar

 -- Mike Hosmar <mhosmar@clearpathrobotics.com>  Wed, 25 Jul 2018 04:00:00 -0000

ros-kinetic-spinnaker-camera-driver (0.1.0-0xenial) xenial; urgency=high

  * Initial Release
  * Contributors: Michael Hosmar

 -- Mike Hosmar <mhosmar@clearpathrobotics.com>  Tue, 24 Jul 2018 04:00:00 -0000

=== debian/control ===
Source: ros-kinetic-spinnaker-camera-driver
Section: misc
Priority: extra
Maintainer: Mike Hosmar <mhosmar@clearpathrobotics.com>
Build-Depends: debhelper (>= 9.0.0), curl, dpkg, libcurl4-openssl-dev, libusb-1.0-0-dev, ros-kinetic-camera-info-manager, ros-kinetic-catkin, ros-kinetic-diagnostic-updater, ros-kinetic-dynamic-reconfigure, ros-kinetic-image-exposure-msgs, ros-kinetic-image-transport, ros-kinetic-nodelet, ros-kinetic-opencv3, ros-kinetic-roscpp, ros-kinetic-roslaunch, ros-kinetic-roslint, ros-kinetic-sensor-msgs, ros-kinetic-wfov-camera-msgs
Homepage: http://ros.org/wiki/spinnaker_camera_driver
Standards-Version: 3.9.2

Package: ros-kinetic-spinnaker-camera-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libusb-1.0-0-dev, ros-kinetic-camera-info-manager, ros-kinetic-diagnostic-updater, ros-kinetic-dynamic-reconfigure, ros-kinetic-image-exposure-msgs, ros-kinetic-image-proc, ros-kinetic-image-transport, ros-kinetic-nodelet, ros-kinetic-opencv3, ros-kinetic-roscpp, ros-kinetic-sensor-msgs, ros-kinetic-wfov-camera-msgs
Description: Spinnaker camera driver based on Spinnaker.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-spinnaker-camera-driver//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
